
-- Modelling first-class polymorphism

{- Consider

let g :: (forall a.a->a)->(Int,Float)
    g f = (f 1, f 3.2)
in g (\x->x)

-}

-- First attempt

data IntT = One
data FloatT = Pi

-- (\x->x) is translated into an overloaded definition
-- identified by a unique token
data F = F

overload o :: F -> (a->a)
   where o F = \x->x

-- enforce the type signature
rule O(F->t) ==> t=a->a

-- f becomes now an overloaded identifier
g :: F -> (IntT,FloatT)
g f = ( (o f) One, (o f) Pi)

-- we replace (\x->x) by F
e = g F


