
-- modelling the functor class

overload fmap

-- rules to model the behaviour of fmap similar to constructor classes
-- see "Beyond Type Classes" for more details

rule Fmap a ==> a=(b->c)->(fb->fc)

rule Fmap ((b->c)->(fb->fc)), Fmap ((b->c1)->(fb1->fc)) ==> b=b1, fb=fb1

rule Fmap ((b->c)->(fb->fc)), Fmap ((b1->c)->(fb->fc1)) ==> b=b1, fc=fc1

rule Fmap ((b->c)->(fb->fc)), Fmap ((b1->c1)->(fb->fc)) ==> b=b1, c=c1


overload fmap :: (a -> a) -> (a -> a) where
         fmap h = h

-- we need to add in some additional props to complete
-- the above program theory 

rule Fmap (a->b)->(c->a) ==> b=a, c=a

rule Fmap (b->a)->(a->c) ==> b=a, c=a

rule Fmap (a->a)->(b->c) ==> b=a, c=a

rule Fmap (b->c)->(a->a) ==> b=a, c=a



{- generates non-terminating CHR

overload fmap :: (Fmap ((a->b)->(fa1->fb1)), Fmap ((fa1->fb1) -> (fa->fb)))
                 => (a->b)->(fa->fb) where
	 fmap h = fmap (fmap h)
-}

data Fix f = In (f (Fix f))

data Char = A

id x = x

e = fmap id A

{-
type e yields

e  = fmap id A :: Char
-}

