

{- Assume we'd like to express the following class declaration

 class (forall s. Monad (m s)) => StateMonad m

Logically, this states that

 forall m. StateMonad m -> forall s. Monad (m s)

which is equivalent to (by using skolemization)

 forall StateMonad m -> Monad (m Erk)

where Erk is a new type constructor

-}

overload stateMonad

overload monad

data Erk = Erk 

-- Unfortunately, we haven't implemented type application correctly yet.
-- Therefore, we write Monad (m, Erk) instead of Monad (m Erk)
rule StateMonad m ==> Monad (m, Erk)





