


data Nat = Zero | Succ Nat

overload leq :: Nat -> Nat -> Bool where
         leq Zero Zero           = True
         leq Zero(Succ n)        = True
         leq (Succ n) Zero       = False
         leq (Succ n1) (Succ n2) = leq n1 n2


overload insert :: (Leq (a->a->Bool)) => a -> [a] -> [a] where   -- (1)
         insert x [] = [x]
         insert x (y:ys) = if (leq x y) then (x:(y:ys))   
                           else (y:(insert x ys)) 

rule Leq a ==> a=b->b->Bool
rule Insert a ==> a=e->ce->ce
-- modelling functional dependencies
rule Insert (a->b->b), Insert (c->b->b) ==> a=c
-- improvement in case of definition (1)
rule Insert (b->[a]->[a]) ==> b=a





{- shortcut to completion

 initial CHRs:

rule Leq (Int->Int->Bool) <==> True                    (1)
rule Insert (a->[a]->[a]) <==> Leq (a->a->Bool)        (2)

rule Leq a ==> a=b->b->Bool
rule Insert a ==> a=e->ce->ce
rule Insert (a->b->b), Insert (c->b->b) ==> a=c        (3)


build critical pairs, however don't take into account rhs of simps:
(that's more or less what Haskell does)

* cp (2',3) where

rule Insert (a->[a]->[a]) <==> True  (2')

   Insert (a->[a]->[a]), Insert (c->[a]->[a]) -2'-> Insert (c->[a]->[a])

   Insert (a->[a]->[a]), Insert (c->[a]->[a]) -3-> Insert (a->[a]->[a]), Insert (c->[a]->[a]), c=a
                                              -2'-> Insert (c->[a]->[a]), c=a

add

rule Insert (c->[a]->[a]) ==> c=a

DONE!

Completion is now more restricted. Adding

rule Insert (Int->[Float]->[Float]) <==> True

yields non-confluent set of CHRs.

-}
