

-- Chameleon is more flexible than FD's


data Int = I1 | I2 

overload leq :: Int -> Int -> Bool where -- (1)
         leq _ _ = True 
         -- we don't care so much about the actual implementation  

overload insert :: (Leq (a->a->Bool)) => a -> [a] -> [a] where -- (2)
         insert x [] = [x]
         insert x (y:ys) = if (leq x y) then (x:(y:ys))   
                           else (y:(insert x ys)) 

data Float = F1 | F2 

overload insert :: Int -> [Float] -> [Float] where
         insert = undefined
         -- we don't care so much about the actual implementation  

rule Leq a ==> a=b->b->Bool
rule Insert a ==> a=e->ce->ce
rule Insert (a->b->b), Insert (c->b->b) ==> a=c 

-- rules necessary to complete theory, can be
-- automatically generated
rule Leq (a->a->Bool), Insert (b->[a]->[a]) ==> b=a 
rule Insert (b->[Int]->[Int]) ==> b=Int
rule Insert (b->[Float]->[Float]) ==> b=Int
rule Leq (Float->Float->Bool) ==> Int=Float

-- Test

l1 = [insert I1 [F1]]

l2 x = insert x [F1]


{- completion process

 initial CHRs:

rule Leq (Int->Int->Bool) <==> True                    (1)
rule Insert (a->[a]->[a]) <==> Leq (a->a->Bool)        (2)
rule Insert (Int->[Float]->[Float]) <==> True          (3)

rule Leq a ==> a=b->b->Bool
rule Insert a ==> a=e->ce->ce
rule Insert (a->b->b), Insert (c->b->b) ==> a=c        (4)

build critical pairs

* cp (2,4)

  Insert (a->[a]->[a]), Insert (c->[a]->[a]) -2-> Leq (a->a->Bool), Insert (c->[a]->[a]) 

  Insert (a->[a]->[a]), Insert (c->[a]->[a]) -4-> Insert (a->[a]->[a]), Insert (c->[a]->[a]), a=c
                                             -2-> Leq (a->a->Bool), Insert (c->[a]->[a]), a=c

  add 

rule  Leq (a->a->Bool), Insert (c->[a]->[a]) ==> a=c (5)

* cp (1,5)

  Leq (Int->Int->Bool), Insert (c->[Int]->[Int]) -1-> Insert (c->[Int]->[Int])
 
  Leq (Int->Int->Bool), Insert (c->[Int]->[Int]) -5-> Leq (Int->Int->Bool), Insert (c->[Int]->[Int]), c=Int
                                                 -1-> Insert (c->[Int]->[Int]), c=Int

add

rule Insert (c->[Int]->[Int]) ==> c=Int  (6)

 
* cp (3,4)

  Insert (Int->[Float]->[Float]), Insert (c->[Float]->[Float]) -3->  Insert (c->[Float]->[Float])

  Insert (Int->[Float]->[Float]), Insert (c->[Float]->[Float]) -4-> Insert (Int->[Float]->[Float]), 
                                                                    Insert (c->[Float]->[Float]), c=Int
                                                               -3-> Insert (c->[Float]->[Float]), c=Int

add

rule Insert (c->[Float]->[Float]) ==> c=Int (7)

* cp (4,5)

  Leq (Float->Float->Bool), Insert (Int->[Float]->[Float]) -4-> Leq (Float->Float->Bool)

  Leq (Float->Float->Bool), Insert (Int->[Float]->[Float]) -5->  Leq (Float->Float->Bool), 
                                                                 Insert (Int->[Float]->[Float]), Int=Float
                                                           -4-> Leq (Float->Float->Bool), Int=Float

add

rule Leq (Float->Float->Bool) ==> Int=Float

DONE!

-}