

-- a generalization of Monads

overload bind
overload return
overload monad

rule Bind x   ==> x=ma->(a->mb)->mb
rule Return x ==> x=a->ma

rule Return (a->b), Return (c->b) ==>a=c

rule Bind (ma->(a->mb)->mb), Return (c->ma) ==> a=c

-- chameleon inferencer wont' terminate !!!
-- (rule doesn't make sense, but funny why we get a non-terminating CHR)
-- Hm, problem seems to have been disappeared !!!
--rule Bind x, Return y ==> x=ma->(a->mb)->mb, y=a->ma

--rule Bind (ma->(a->mb)->mb), Bind (ma->(a'->mc)->mc) ==> a=a'

erk3 :: (Bind (ma->(a->mb)->mb)) => ma -> mb
erk3 = undefined

rule Bind (ma->(a->mb)->mb) ==> Return (a->ma)
-- Every bind must come with a return
--rule Return (a->ma) ==> Bind (ma->(a->mb)->mb)
-- Unfortunately, we cannot enforce the same the other way around.
-- Note that mb in the above rule
-- is unconstrained. Therefore, we get a non-confluent error.
-- We could work around this problem by imposing the following rule.
-- rule Bind (ma->(a->mb)->mb), Bind (ma->(a->mc)->mc) ==> mc=mb
-- However, this seems to be too restrictive.
-- What we need is an ad-hoc test to check that both instances are defined.
-- This ad-hoc test would signal an error early. We would get an error in case
-- we are requesting a undefined instance.

-- We'd like to state that every mb comes with a bind.
-- The rule below yields a non-terminating set of CHRs though.
--rule Bind (ma->(a->mb)->mb) ==> Bind (mb->(b->mc)->mc)
-- Essentially, we want to check that every bind satisfies
-- forall b,mb,mc. Bind (mb->(b->mc)->mc) => ma->(a->mb)->mb
-- for specific a and ma.
-- Can't see how to code up entailment test in terms of CHRs.


data E a = Succ a | Err

--rule Bind (E a->(b->mb)->mb) ==> b=a


{-
overload bind :: E a -> (a -> E b) -> E b
         bind (Succ a) k = k a
         bind Err k      = Err
-}

overload bind :: E a -> (a -> E b) -> E b
   where bind = let f (Succ a) k = k a
                    f Err k      = Err
                in forget f (mycheck check f) 
-- Entailment check should fail here !!!
-- We need to impose

rule Bind (E a -> x) ==> x= (a -> E b) -> E b

check :: (Bind (mb->(b->mc)->mc)) => ma->(a->mb)->mb
check = undefined

forget :: a->a->a
forget x y = x

overload mycheck
rule Mycheck x <==> x=a->a->a
         
g (Succ a) k = k a
g Err k      = Err


erk :: E a -> (a-> E b)-> E b
erk = forget g (mycheck check g)


rule Return (a->E b) ==> b=a

overload return :: a -> E a
   where return a = Succ a

data Maybe a = Just a | Nothing

rule Bind (Maybe a ->(b->mc)->mc) ==> b=a

overload bind :: (Bind (mb->(b->mb)->mb), Return (b->mb)) => Maybe a ->(a->mb)->mb
   where bind (Just a) k = k a
         bind Nothing k      = bind ((return undefined)::mb) k
                               -- scoped type variable necessary, otherwise we infer an
                               -- ambiguous type scheme


{-
erk2 :: (Bind (mb->(b->mb)->mb), Return (b->mb)) => Maybe a ->(a->mb)->mb
erk2 = let b (Just a) k = k a
           b Nothing k  = bind ((return undefined)::mb) k
                               -- scoped type variable necessary, otherwise we infer an
                               -- ambiguous type scheme
       in forget b (mycheck check b)
-}

rule Return (a->Maybe b) ==>b=a

overload return :: a -> Maybe a
   where return x = Just x

