

-- result of type-level computations
data T = T
data F = F

data Zero   = Zero
data Succ n = Succ n


overload leq :: Zero -> Zero -> T
   where leq Zero Zero = T
overload leq :: (Leq (a->b->c)) => Succ a -> Succ b -> c
   where leq (Succ a) (Succ b) = leq a b
overload leq :: Zero -> Succ a -> T
   where leq Zero (Succ a) = T
overload leq :: Succ a -> Zero -> F
   where leq (Succ a) Zero = F

{- these rules are important otherwise we can't check
   the inferred type of lookup against the declared type -}
rule Leq a                        ==> a=b->c->d
rule Leq (a->b->c), Leq (a->b->d) ==> c=d
rule Leq (Zero->Zero->a)          ==> a=T
rule Leq (Succ a->Zero->b)        ==> b=F 
rule Leq (Zero->Succ a->b)        ==> b=T     

data Nil      = Nil
data Cons a b = Cons a b


overload append :: Nil -> a -> a
   where append Nil xs = xs
overload append :: (Append (xs->ys->zs)) => (Cons x xs) -> ys -> (Cons x zs)
   where append (Cons x xs) ys = Cons x (append xs ys)

rule Append a ==> a=b->c->d
rule Append (a->b->c), Append (a->b->d) ==> c=d
rule Append (Nil->a->b) ==> a=b
rule Append ((Cons x xs)->ys->zs) ==> zs=Cons x zs'
