

data L = L
data R a b = R a b
data B a b = B a b

and = (\ x -> \ y -> True) :: Bool->Bool->Bool


{- red-black tree -}
overload rbt :: L -> Bool
   where rbt L = True
overload rbt :: (Bt (a->Bool), Bt (b->Bool)) => (R a b) -> Bool
   where rbt (R a b) = and (bt a) (bt b)
overload rbt :: (Rbt (a->Bool), Rbt (b->Bool)) => (B a b) -> Bool
   where rbt (B a b) = and (rbt a) (rbt b)

{- black tree -}
overload bt :: L -> Bool
   where bt L = True
overload bt :: (Rbt (a->Bool), Rbt (b->Bool)) => (B a b) -> Bool
   where bt (B a b) = and (rbt a) (rbt b)


{- one color violation in the top node -}

overload almost :: (Rbt (a->Bool), Rbt (b->Bool)) 
                    => (R (R a b) L) -> Bool
   where almost (R (R a b) L) = and (rbt a) (rbt b)
overload almost :: (Rbt (a->Bool), Rbt (b->Bool), Rbt (c->Bool), Rbt (d->Bool)) 
                    => (R (R a b) (B c d)) -> Bool
   where almost (R (R a b) (B c d)) = and (and (rbt a) (rbt b))
                                          (and (rbt c) (rbt d))
overload almost :: (Rbt (b->Bool), Rbt (c->Bool)) 
                    => (R L (R b c)) -> Bool
   where almost (R L (R b c)) = and (rbt b) (rbt c)
overload almost :: (Rbt (a->Bool), Rbt (b->Bool), Rbt (c->Bool), Rbt (d->Bool))
                    => (R (B a b) (R c d)) -> Bool
   where almost (R (B a b) (R c d)) = and (and (rbt a) (rbt b))
                                          (and (rbt c) (rbt d))



rule Rbt a              ==> a=b->Bool
rule Bt a               ==> a=b->Bool
rule Bt ((R a b)->Bool) ==> L=Bool



overload restore :: (R (R a b) c,d) -> (R (B a b) (B c d))
   where restore ((R (R a b) c),d) = R (B a b) (B c d)
overload restore :: (R a (R b c),d) -> (R (B a b) (B c d))
   where restore ((R a (R b c)),d) = R (B a b) (B c d)
overload restore :: (a, R (R b c) d) -> (R (B a b) (B c d))
   where restore (a, (R (R b c) d)) = R (B a b) (B c d)
overload restore :: (a, R b (R c d)) -> (R (B a b) (B c d))
   where restore (a, (R b (R c d))) = R (B a b) (B c d)
overload restore :: (a,b) -> (B a b)
   where restore (a,b) = (B a b)


{- Lemma:

   Almost (a), Restore(a->b) ==> Rbt (b)

  what about confluence

-}
