
{- A sample run

chameleon -d --no-term --no-rr samples/superclass.ch 
_______________
-- Chameleon --

  Checking locations [130,156,159,163]
  Well-typed
  Solver Mode: 0
  Justification Policy: local


-}

---- Encoding of superclasses:
--
-- class A a where f :: a -> Int
-- class A a => B a where g :: a -> Int
--
-- instance A Int where f x = 1
-- instance B Int where g x = 2

---- Simulate integers

data Nat = Zero | Succ Nat
data Int = Pos Nat | Neg Nat  -- Neg n with n <> Zero


---- Constraint abbreviations are not implemented yet...
--
-- constraint A a = F (a->Int)
-- constraint B a = G (a->Int)
--
-- rule F x ==> x = a->Int, A a
-- rule G x ==> x = a->Int, B a
-- rule B a ==> A a
--
---- Thus:

rule F x ==> x = a->Int, F (a->Int)
rule G x ==> x = a->Int, G (a->Int)
rule G (a->Int) ==> F (a->Int)

overload f :: Int -> Int where
         f x = Pos (Succ Zero)
overload g :: Int -> Int where
         g x = Pos (Succ (Succ Zero))


-- Example:

f' = f
g' = g
