

-- In first step, we model addition and subtraction.

data Zero = Zero
data Succ n = Succ n
data Pred n = Pred n

zero = Zero
one = Succ zero
two = Succ one

overload add
overload sub

rule Add(a,b,c1),Add(a,b,c2) ==> c1=c2 
rule Add(Zero,a,b) ==> a=b 
rule Add(a,Zero,b) ==> a=b 
rule Add(Succ a, Pred b, c) <==> Add(a,b,c) 
rule Add(Pred a, Succ b, c) <==> Add(a,b,c) 
rule Add(Succ a, Succ b, c1) <==> Add(a,b,c2),c1=Succ (Succ c2) 
rule Add(Pred a, Pred b, c1) <==> Add(a,b,c2),c1=Pred (Pred c2) 
data X = X; -- need to mimic the always True constraint
rule Add(a,Zero,a) <==> X=X 
rule Add(Zero,a,a) <==> X=X

rule Sub(a,b,c1),Sub(a,b,c2) ==> c1=c2 
rule Sub(a,Zero,b)           ==> a=b 
rule Sub(Zero,Succ a,b1)    <==> Sub(Zero,a,b2),b1=Pred b2 
rule Sub(Succ a, Succ b, c) <==> Sub(a,b,c) 
rule Sub(Succ a, Pred b, c) <==> Sub(Succ (Succ a),b,c) 
rule Sub(Pred a, Succ b, c) <==> Sub(Pred (Pred a),b,c) 
rule Sub(Pred a, Pred b, c) <==> Sub(a,b,c) 
rule Sub(a,Zero,a)          <==> X=X 

{- Each unit type is represented by a record.
   Multiplication (division) of two unit types is equivalent to 
   adding (subtracting) the corresponding unit entries.
   We'll assume that all unit information is stored in record constraints. -}

overload rec
overload plus
overload mult
overload div


rule Rec(u->v1->r),Rec(u->v2->r)   ==> v1=v2 
rule Mult(r1->r2->r3),Rec(u->v1->r1),Rec(u->v2->r2) ==> Rec(u->v3->r3), Add(v1,v2,v3) 
rule Div(r1->r2->r3),Rec(u->v1->r1),Rec(u->v2->r2)  ==> Rec(u->v3->r3), Sub(v1,v2,v3)


rule Mult a ==> a=r1->r2->r3
rule Div a ==> a=r1->r2->r3
rule Plus a ==> a=r->r->r
 

-- For simplicity, we only consider three units: feet, meter, miles -}

data Feet = Feet
data Meter = Meter
data Miles = Miles


-- declaring a value two of type Feet^2 means generating constraints
-- Rec(Feet->(Succ (Succ Zero))->r), Rec(Meter->Zero,r), Rec(Miles->Zero->r)
-- where r is the unit type


overload buildFeet
ft x = buildFeet x
rule BuildFeet (v->r) <==> Rec(Feet->v->r), Rec(Meter->Zero,r), Rec(Miles->Zero->r)

overload buildMeter
mt x = buildMeter x
rule BuildMeter (v->r) <==> Rec(Feet->Zero->r), Rec(Meter->v,r), Rec(Miles->Zero->r)

overload buildMiles
mi x = buildFeet x
rule BuildMiles (v->r) <==> Rec(Feet->Zero->r), Rec(Meter->Zero,r), Rec(Miles->v->r)



exp1 = mult (ft one) (ft one)

exp2 = plus (ft one) (div (ft two) (ft one))

-- this expression yields a type error
--exp3 = plus (ft two) (div (ft two) (ft one))
