

--zip2 :: [a] -> [b] -> [(a,b)]
zip2 (x:xs) (y:ys) = (x,y) : (zip2 xs ys) 
zip2 _ _ = [] 

-- base case
overload zip :: [a]->[b]->[(a,b)]  where
   zip= zip2

-- general case
overload zip :: (Zip ([(a,b)]->cs->r)) => [a]->[b]->cs->r where
         zip as bs cs = zip (zip2 as bs) cs 

-- additionl properties
rule Zip ([a]->[b]->[c]) ==> c=(a,b)
rule Zip (a->b->c)       ==> a=[a'], b=[b'] 

-- we don't allow (yet) for type annotations of HM expressions
-- FIXED in latest Chameleon version
overload annot :: a->a->a where
         annot x y = x 

rule Annot a ==> a=b->b->b

-- instead of
-- exp :: t
-- exp = body
-- write 
-- exp = annot body expt
-- where expt is a value of type t


-- need to mimic Int and Char
data Int = One 
data Char = C 

t1 = [((One,True),C)] 

-- e1 :: [((Int,Bool),Char)]
e1 = annot (zip [One,One] [True,False] [C,C]) t1 

t2 = [] 

e2 = annot (zip [One,One] [True,False]) t2 
